"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var ts = __importStar(require("typescript"));
var core_1 = require("@babel/core");
var ts_transform_css_in_js_1 = __importDefault(require("@compiled/ts-transform-css-in-js"));
/**
 * Using a stub program means type checking won't work - of course.
 */
var stubProgam = {
    getTypeChecker: function () { return ({
        getSymbolAtLocation: function () { return undefined; },
    }); },
};
function compiledBabelPlugin(_, opts) {
    if (opts === void 0) { opts = {}; }
    return {
        parserOverride: function (code, parserOpts, parse) {
            var _a;
            if (code.indexOf('@compiled/css-in-js') === -1) {
                // Bail early if there is no work to do.
                return parse(code, parserOpts);
            }
            var userLandFlowPlugin = (parserOpts.plugins || []).find(function (plugin) {
                return plugin === 'flow' || plugin[0] === 'flow';
            });
            var parsedCode = code;
            if (userLandFlowPlugin) {
                // If the userland Babel config is Flow we need to strip it before passing it to the TypeScript
                // transformer else it'll blow up because TypeScript doesn't support Flow syntax.
                // We're going down a slippery slope - later we might want to investigate a re-write to Babel.
                // See: https://github.com/atlassian-labs/compiled-css-in-js/issues/196
                parsedCode =
                    ((_a = core_1.transformSync(parsedCode, {
                        babelrc: false,
                        configFile: false,
                        plugins: ['@babel/plugin-syntax-jsx', '@babel/plugin-transform-flow-strip-types'],
                    })) === null || _a === void 0 ? void 0 : _a.code) || parsedCode;
            }
            var transformedCode = ts.transpileModule(parsedCode, {
                transformers: { before: [ts_transform_css_in_js_1.default(stubProgam, { options: opts })] },
                compilerOptions: {
                    module: ts.ModuleKind.ESNext,
                    target: ts.ScriptTarget.ESNext,
                    jsx: ts.JsxEmit.Preserve,
                },
            });
            return parse(transformedCode.outputText, parserOpts);
        },
    };
}
exports.default = compiledBabelPlugin;
//# sourceMappingURL=index.js.map